//------------------------------------------------------------------------------
//
//   Greg's Blocks - BlockSawbench
//
//------------------------------------------------------------------------------

package gcewing.blocks;

import java.util.ArrayList;
import net.minecraft.block.*;
import net.minecraft.block.material.*;
import net.minecraft.client.renderer.texture.*;
import net.minecraft.creativetab.*;
import net.minecraft.entity.*;
import net.minecraft.entity.player.*;
import net.minecraft.item.*;
import net.minecraft.tileentity.*;
import net.minecraft.util.*;
import net.minecraft.world.*;

public class BlockSawbench extends BlockContainer {

	Icon textures[] = new Icon[6];

	public BlockSawbench(int id) {
//		super(id, 0x00, Material.wood);
		super(id, Material.wood);
	}
	
//	@Override
//	public String getTextureFile() {
//		return GregsBlocks.textureFile;
//	}
	
//	public void addCreativeItems(ArrayList itemList) {
//		itemList.add(new ItemStack(this, 1));
//	}

	@Override
	public CreativeTabs getCreativeTabToDisplayOn() {
		return CreativeTabs.tabMisc;
	}
	
	@Override
	public void registerIcons(IconRegister reg) {
		textures[0] = getIcon(reg, "sawbench-top-ns");
		textures[1] = getIcon(reg, "sawbench-top-ew");
		textures[2] = getIcon(reg, "sawbench-right");
		textures[3] = getIcon(reg, "sawbench-front");
		textures[4] = getIcon(reg, "sawbench-left");
		textures[5] = getIcon(reg, "sawbench-back");
	}
	
	Icon getIcon(IconRegister reg, String name) {
		String modPackage = getClass().getPackage().getName();
		return reg.registerIcon(modPackage + ":" + name);
	}

	@Override
	public void onBlockPlacedBy(World world, int x, int y, int z, EntityLiving player, ItemStack stack) {
		int angle = MathHelper.floor_double((player.rotationYaw * 4.0 / 360.0) + 0.5) & 3;
		//System.out.printf("BlockSawbench.onBlockPlacedBy: angle = %d\n", angle);
		world.setBlockMetadataWithNotify(x, y, z, angle, 0x3);
	}
	
	@Override
	public Icon getBlockTextureFromSideAndMetadata(int side, int data) {
		int offset = 0;
		if (side == 0)
			offset = 5;
		else if (side == 1)
			offset = data & 1;
		else {
			int angle = 0;
			switch (side) {
				case 2: angle = 0; break;	// -X
				case 3: angle = 2; break; // +X
				case 4: angle = 1; break; // -Z
				case 5: angle = 3; break; // +Z
			}
			switch ((angle + data) & 3) {
				case 0: offset = 3; break; // -X
				case 1: offset = 2; break; // -Z
				case 2: offset = 4; break; // +X
				case 3: offset = 5; break; // +Z
			}
		}
//		return blockIndexInTexture + offset;
		return textures[offset];
	}

	@Override
	public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer player,
		int par6, float par7, float par8, float par9)
	{
		//System.out.printf("BlockSawbench.onBlockActivated\n");
		if (!player.isSneaking()) {
			if (!world.isRemote) {
				//System.out.printf("BlockSawbench.onBlockActivated: opening gui\n");
				GregsBlocks.mod.openGuiSawbench(world, x, y, z, player);
			}
			return true;
		}
		else
			return false;
	}

	@Override
	public TileEntity createNewTileEntity(World world) {
		return new TESawbench();
	}

//	public void onBlockRemoval(World world, int x, int y, int z) {

	@Override
	public void onBlockDestroyedByPlayer(World world, int x, int y, int z, int data) {
		Utils.dumpInventoryIntoWorld(world, x, y, z);
		super.onBlockDestroyedByPlayer(world, x, y, z, data);
	}
	
}
